openapi: 3.0.1
info:
  title: ANCHOR NSMF Catalogue Management API
  termsOfService: urn:tos
  contact: {}
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0
  version: "1.0"
servers:
- url: /
tags:
- name: NEST Management API
  description: NEST Catalogue Management API
- name: NST Management API
  description: NST  Catalogue Management API
paths:
  /nsmf/catalogue/nestemplate:
    get:
      tags:
      - NEST Management API
      summary: Get all NEST templates
      operationId: getAllNesTemplatesUsingGET
      responses:
        200:
          description: OK
          content:
            '*/*':
              schema:
                type: object
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
    post:
      tags:
      - NEST Management API
      summary: Onboard NEST 
      operationId: createNsTemplateUsingPOST
      parameters:
      - name: authenticated
        in: query
        schema:
          type: boolean
      - name: authorities[0].authority
        in: query
        schema:
          type: string
      requestBody:
        description: request
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/OnBoardNesTemplateRequest'
        required: true
      responses:
        200:
          description: OK
          content:
            '*/*':
              schema:
                type: object
        201:
          description: Created
          content: {}
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
      x-codegen-request-body-name: request
  /nsmf/catalogue/nestemplate/{nestId}:
    get:
      tags:
      - NEST Management API
      summary: Get NEST with specified ID
      operationId: getNsTemplateUsingGET
      parameters:
      - name: nestId
        in: path
        description: nestId
        required: true
        schema:
          type: string
      responses:
        200:
          description: OK
          content:
            '*/*':
              schema:
                type: object
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
    delete:
      tags:
      - NEST Management API
      summary: Delete NEST with specified ID
      operationId: deleteNsTemplateUsingDELETE
      parameters:
      - name: authenticated
        in: query
        schema:
          type: boolean
      - name: authorities[0].authority
        in: query
        schema:
          type: string
      - name: nestId
        in: path
        description: nestId
        required: true
        schema:
          type: string
      responses:
        200:
          description: OK
          content:
            '*/*':
              schema:
                type: object
        204:
          description: No Content
          content: {}
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
      deprecated: false
  /nsmf/catalogue/nsstemplate:
    get:
      tags:
      - NST Management API
      summary: Get ALL the NSTs
      operationId: getAllNssTemplatesUsingGET
    
      responses:
        200:
          description: List of all the NSSTs
          content:
            '*/*':
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/NssTemplateInfo'
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
      x-codegen-request-body-name: nsstIds
    post:
      tags:
      - NST Management API
      summary: Onboard a new NSST
      operationId: createNssTemplateUsingPOST
      parameters:
      - name: authenticated
        in: query
        schema:
          type: boolean
      - name: authorities[0].authority
        in: query
        schema:
          type: string
      requestBody:
        description: request
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/OnBoardNssTemplateRequest'
        required: true
      responses:
        201:
          description: The ID of the created NSST info record.
          content:
            '*/*':
              schema:
                type: string
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
      x-codegen-request-body-name: request
  /nsmf/catalogue/nsstemplate/{nsstId}:
    get:
      tags:
      - NST Management API
      summary: Get a NSST with a specified  id
      operationId: getNssTemplateUsingGET
      parameters:
      - name: nsstId
        in: path
        description: nsstId
        required: true
        schema:
          type: string
      responses:
        200:
          description: NST with specified NSST id
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/NsTemplateInfo'
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
    delete:
      tags:
      - NST Management API
      summary: Delete a NSST with a given ID
      operationId: deleteNssTemplateUsingDELETE
      parameters:
      - name: authenticated
        in: query
        schema:
          type: boolean
      - name: authorities[0].authority
        in: query
        schema:
          type: string
      - name: nsstId
        in: path
        description: nsstId
        required: true
        schema:
          type: string
      responses:
        200:
          description: OK
          content:
            '*/*':
              schema:
                type: object
        204:
          description: Empty
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/ResponseEntity'
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
      deprecated: false
  /nsmf/catalogue/nstemplate:
    get:
      tags:
      - NST Management API
      summary: Get ALL the NSTs
      operationId: getAllNsTemplatesUsingGET
      responses:
        200:
          description: List of all the NSTs
          content:
            '*/*':
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/NsTemplateInfo'
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
    post:
      tags:
      - NST Management API
      summary: Onboard a new NST
      operationId: createNsTemplateUsingPOST_1
      parameters:
      - name: authenticated
        in: query
        schema:
          type: boolean
      - name: authorities[0].authority
        in: query
        schema:
          type: string
      requestBody:
        description: request
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/OnBoardNsTemplateRequest'
        required: true
      responses:
        201:
          description: The ID of the created NST info record.
          content:
            '*/*':
              schema:
                type: string
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
      x-codegen-request-body-name: request
  /nsmf/catalogue/nstemplate/{nstId}:
    get:
      tags:
      - NST Management API
      summary: Get a NST with a specified  id
      operationId: getNsTemplateUsingGET_1
      parameters:
      - name: nstId
        in: path
        description: nstId
        required: true
        schema:
          type: string
      responses:
        200:
          description: NST with specified NST id
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/NsTemplateInfo'
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
        404:
          description: Not Found
          content: {}
      deprecated: false
    delete:
      tags:
      - NST Management API
      summary: Delete a NST with a given ID
      operationId: deleteNsTemplateUsingDELETE_1
      parameters:
      - name: authenticated
        in: query
        schema:
          type: boolean
      - name: authorities[0].authority
        in: query
        schema:
          type: string
      - name: nstId
        in: path
        description: nstId
        required: true
        schema:
          type: string
      responses:
        200:
          description: OK
          content:
            '*/*':
              schema:
                type: object
        204:
          description: Empty
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/ResponseEntity'
        401:
          description: Unauthorized
          content: {}
        403:
          description: Forbidden
          content: {}
      deprecated: false
  
components:
  schemas:
    AddressData:
      title: AddressData
      type: object
      properties:
        addressType:
          type: string
          enum:
          - MAC_ADDRESS
          - IP_ADDRESS
        floatingIpActivated:
          type: boolean
        iPAddressAssignment:
          type: boolean
        iPAddressType:
          type: string
          enum:
          - IPv4
          - IPv6
        management:
          type: boolean
        numberOfIpAddress:
          type: integer
          format: int32
    AffinityOrAntiAffinityGroup:
      title: AffinityOrAntiAffinityGroup
      type: object
      properties:
        affinityOrAntiAffinity:
          type: string
          enum:
          - AFFINITY
          - ANTI_AFFINITY
        groupId:
          type: string
        scope:
          type: string
          enum:
          - NFVI_NODE
          - NFVI_POP
          - ZONE
          - ZONE_GROUP
    AffinityRule:
      title: AffinityRule
      type: object
      properties:
        affinityOrAntiAffinity:
          type: string
          enum:
          - AFFINITY
          - ANTI_AFFINITY
        scope:
          type: string
          enum:
          - NFVI_NODE
          - NFVI_POP
          - ZONE
          - ZONE_GROUP
    AreaOfService:
      title: AreaOfService
      type: object
      properties:
        areaOfService:
          type: string
        regionSpecification:
          type: array
          items:
            type: string
    AutoscalingAction:
      title: AutoscalingAction
      type: object
      properties:
        scaleNsToLevelData:
          $ref: '#/components/schemas/ScaleNsToLevelData'
        scaleType:
          type: string
          enum:
          - SCALE_NS
          - SCALE_VNF
    AutoscalingRuleCondition:
      title: AutoscalingRuleCondition
      type: object
      properties:
        cooldownTime:
          type: integer
          format: int32
        enabled:
          type: boolean
        initialInstantiationLevel:
          type: string
        name:
          type: string
        scaleInOperationType:
          type: string
          enum:
          - AND
          - OR
        scaleOutOperationType:
          type: string
          enum:
          - AND
          - OR
        scalingCriteria:
          type: array
          items:
            $ref: '#/components/schemas/AutoscalingRuleCriteria'
        scalingType:
          type: string
          enum:
          - MANUAL_SCALING
          - AUTOMATED_SCALING
        thresholdTime:
          type: integer
          format: int32
    AutoscalingRuleCriteria:
      title: AutoscalingRuleCriteria
      type: object
      properties:
        name:
          type: string
        nsMonitoringParamRef:
          type: string
        scaleInRelationalOperation:
          type: string
          enum:
          - GE
          - LE
          - GT
          - LT
          - EQ
        scaleInThreshold:
          type: integer
          format: int32
        scaleOutRelationalOperation:
          type: string
          enum:
          - GE
          - LE
          - GT
          - LT
          - EQ
        scaleOutThreshold:
          type: integer
          format: int32
    ConnectivityType:
      title: ConnectivityType
      type: object
      properties:
        flowPattern:
          type: string
        layerProtocol:
          type: string
          enum:
          - ETHERNET
          - MPLS
          - ODU2
          - IPV4
          - IPV6
          - PSEUDO_WIRE
          - OTSIA
          - OCH
          - OTU
          - ODU
          - SDM
          - AROF
          - OBFN
          - NOT_SPECIFIED
  
    Dependencies:
      title: Dependencies
      type: object
      properties:
        primaryId:
          type: array
          items:
            type: string
        secondaryId:
          type: array
          items:
            type: string
    DeterministicCommunication:
      title: DeterministicCommunication
      type: object
      properties:
        detCommAvailability:
          type: boolean
        detCommPeriodicity:
          type: array
          items:
            type: number
            format: float
    DownlinkThroughputNS:
      title: DownlinkThroughputNS
      type: object
      properties:
        additionalDl:
          type: boolean
        guardanteedDLQuota:
          type: integer
          format: int32
        maximumDL:
          type: integer
          format: int32
    EMBBPerfReq:
      title: EMBBPerfReq
      type: object
      properties:
        activityFactor:
          type: integer
          format: int32
        areaTrafficCapDL:
          type: integer
          format: int32
        areaTrafficCapUL:
          type: integer
          format: int32
        expDataRateDL:
          type: integer
          format: int32
        expDataRateUL:
          type: integer
          format: int32
        overallUserDensity:
          type: integer
          format: int32
    EnergyEfficiency:
      title: EnergyEfficiency
      type: object
      properties:
        nsEnergyEfficiency:
          type: integer
          format: int32
        timeFrameMeasur:
          type: integer
          format: int32
    GST:
      title: GST
      type: object
      properties:
        areaOfServices:
          type: array
          items:
            $ref: '#/components/schemas/AreaOfService'
        availability:
          type: number
          format: float
        delayTolerance:
          type: boolean
        deterministicCommunication:
          $ref: '#/components/schemas/DeterministicCommunication'
        downlinkThroughputNS:
          $ref: '#/components/schemas/DownlinkThroughputNS'
        energyEfficiency:
          $ref: '#/components/schemas/EnergyEfficiency'
        groupCommunicationSupport:
          type: string
          enum:
          - NotSupported
          - SCPTM
          - Broadcast_multicast
          - Broadcast_multicast_SCPTM
        gstId:
          type: string
        gstName:
          type: string
        gstProvider:
          type: string
        gstVersion:
          type: string
        isolation:
          $ref: '#/components/schemas/Isolation'
        latencyApplicationServer:
          type: number
          format: float
        maxNPDUsess:
          $ref: '#/components/schemas/MaxNPDUsess'
        maxNUE:
          $ref: '#/components/schemas/MaxNUE'
        maxSuppPacketSize:
          type: integer
          format: int32
        maxUplinkThroughputUE:
          type: integer
          format: int32
        maximumDownlinkThroughputUE:
          type: integer
          format: int32
        missionCriticalSupport:
          $ref: '#/components/schemas/MissionCriticalSupport'
        mmTelSupport:
          type: boolean
        mpsSupport:
          $ref: '#/components/schemas/MultimediaPriorityServiceSupp'
        nbIoTSupport:
          type: boolean
        nfOwned:
          type: array
          items:
            type: string
        nssaarequired:
          type: boolean
        performanceMonitoring:
          $ref: '#/components/schemas/PerformanceMonitoring'
        performancePrediction:
          $ref: '#/components/schemas/PerformancePrediction'
        positioningSupport:
          $ref: '#/components/schemas/PositioningSupport'
        radioSpectrum:
          $ref: '#/components/schemas/RadioSpectrum'
        rootCauseInvestigation:
          type: string
          enum:
          - NotSupported
          - PassiveInvestigation
          - ActiveInvestigation
        simultUseNSlice:
          type: string
          enum:
          - AnyNetSlice
          - SameSSTdiffSD
          - SameSDdiffSST
          - CannotBeUsed
          - OpDefinedClass
        sliceQoSparams:
          type: array
          items:
            $ref: '#/components/schemas/SliceQoSparams'
        sscSupport:
          type: string
          enum:
          - SSCmode1
          - SSCmode2
          - SSCmode3
        supportNonIpTraffic:
          type: boolean
        supportedDeviceVelocity:
          type: integer
          format: int32
        synchronicity:
          $ref: '#/components/schemas/Synchronicity'
        ueDensity:
          type: integer
          format: int32
        uplinkThroughputNS:
          $ref: '#/components/schemas/UplinkThroughputNS'
        userDataAccess:
          $ref: '#/components/schemas/UserDataAccess'
        userManagementOpeness:
          type: boolean
        v2xCommunicationMode:
          type: string
          enum:
          - NotSupported
          - YES_EUTRA
          - YES_NR
          - YES_NRandEUTRA
  
    Isolation:
      title: Isolation
      type: object
      properties:
        isolationLevel:
          type: string
          enum:
          - NoIsolation
          - Physical
          - Logical
        logicalIsolation:
          type: string
          enum:
          - VirtualResourceIsolation
          - NetworkFunctionIsolation
          - Tenant_ServiceIsolation
        physicalIsolation:
          type: string
          enum:
          - ProcessAndThreadIsolation
          - PhysicalMemoryIsolation
          - PhysicalNetworkIsolation
    LifeCycleManagementScript:
      title: LifeCycleManagementScript
      type: object
      properties:
        event:
          type: array
          items:
            type: string
            enum:
            - START_VNF_INSTANTIATION
            - END_VNF_INSTANTIATION
            - START_VNF_SCALING
            - END_VNF_SCALING
            - START_VNF_HEALING
            - END_VNF_HEALING
            - START_VNF_TERMINATION
            - END_VNF_TERMINATION
            - START_VNF_FLAVOUR_CHANGE
            - END_VNF_FLAVOUR_CHANGE
            - START_VNF_OP_STATE_CHANGE
            - END_VNF_OP_STATE_CHANGE
            - START_CHANGE_VNF_EXTERNAL_CONNECTIVITY
            - END_CHANGE_VNF_EXTERNAL_CONNECTIVITY
            - RECEIVED_MSG_VNF_INSTANTIATE
            - RECEIVED_MSG_VNF_SCALE
            - RECEIVED_MSG_VNF_HEAL
            - RECEIVED_MSG_VNF_TERMINATE
            - RECEIVED_MSG_CHANGE_VNF_FLAVOUR
            - RECEIVED_MSG_CHANGE_VNF_EXTERNAL_CONNECTIVITY
            - RECEIVED_MSG_CHANGE_VNF_OP_STATE
            - RECEIVED_MSG_VNF_CHANGE_INDICATION
            - START_NS_INSTANTIATION
            - END_NS_INSTANTIATION
            - START_NS_SCALING
            - END_NS_SCALING
            - START_NS_HEALING
            - END_NS_HEALING
            - START_NS_TERMINATION
            - END_NS_TERMINATION
            - START_NS_UPDATE
            - END_NS_UPDATE
            - RECEIVED_MSG_NS_INSTANTIATE
            - RECEIVED_MSG_NS_SCALE
            - RECEIVED_MSG_NS_HEAL
            - RECEIVED_MSG_NS_TERMINATE
            - RECEIVED_MSG_NS_UPDATE
        script:
          type: string
    LinkBitrateRequirements:
      title: LinkBitrateRequirements
      type: object
      properties:
        leaf:
          type: string
        root:
          type: string
    MaxNPDUsess:
      title: MaxNPDUsess
      type: object
      properties:
        epscountRequired:
          type: boolean
        maxNPDUsess:
          type: integer
          format: int32
    MaxNUE:
      title: MaxNUE
      type: object
      properties:
        epsCountRequired:
          type: boolean
        maxNUe:
          type: integer
          format: int32
    MissionCriticalSupport:
      title: MissionCriticalSupport
      type: object
      properties:
        mcCapabilitySupport:
          type: array
          items:
            type: string
            enum:
            - Interuser_prioritization
            - Preemption
            - Local_control
        mcServiceSupport:
          type: array
          items:
            type: string
            enum:
            - MCPTT
            - MCData
            - MCVideo
            - MCinterworking
        missionCriticalSupport:
          type: boolean
    MonitoredData:
      title: MonitoredData
      type: object
      properties:
        monitoringParameter:
          $ref: '#/components/schemas/MonitoringParameter'
        vnfIndicatorInfo:
          $ref: '#/components/schemas/VnfIndicatorData'
    MonitoringParameter:
      title: MonitoringParameter
      type: object
      properties:
        exporter:
          type: string
        monitoringParameterId:
          type: string
        name:
          type: string
        params:
          type: object
          additionalProperties:
            type: string
        performanceMetric:
          type: string
        type:
          type: string
    MultimediaPriorityServiceSupp:
      title: MultimediaPriorityServiceSupp
      type: object
      properties:
        mpsSupport:
          type: boolean
        mpscSupport:
          type: array
          items:
            type: string
            enum:
            - UserPrioritization
            - PreEmption
        multimediaPriorityServSupp:
          type: array
          items:
            type: string
            enum:
            - MMTelVoice
            - MMTelVideo
            - Data
    NSST:
      title: NSST
      type: object
      properties:
        administrativeState:
          type: string
          enum:
          - LOCKED
          - UNLOCKED
          - SHUTTINGDOWN
        nsInfo:
          $ref: '#/components/schemas/NsInfo'
        nsdInfo:
          $ref: '#/components/schemas/NsdInfo'
        nsstId:
          type: string
        nsstList:
          type: array
          items:
            $ref: '#/components/schemas/NSST'
        nsstName:
          type: string
        nsstProvider:
          type: string
        nsstVersion:
          type: string
        operationalState:
          type: boolean
        sliceProfileList:
          type: array
          items:
            $ref: '#/components/schemas/SliceProfile'
        type:
          type: string
          enum:
          - RAN
          - CORE
          - TRANSPORT
          - VAPP
          - E2E
    NST:
      title: NST
      type: object
      properties:
        administrativeState:
          type: string
          enum:
          - LOCKED
          - UNLOCKED
          - SHUTTINGDOWN
        nsst:
          $ref: '#/components/schemas/NSST'
        nstId:
          type: string
        nstName:
          type: string
        nstProvider:
          type: string
        nstServiceProfileList:
          type: array
          items:
            $ref: '#/components/schemas/NstServiceProfile'
        nstVersion:
          type: string
        operationalState:
          type: boolean
    Nfpd:
      title: Nfpd
      type: object
      properties:
        cpd:
          type: array
          items:
            type: string
        nfpId:
          type: string
        nfpRule:
          $ref: '#/components/schemas/Rule'
        qos:
          $ref: '#/components/schemas/QoS'
    NsAutoscalingRule:
      title: NsAutoscalingRule
      type: object
      properties:
        ruleActions:
          type: array
          items:
            $ref: '#/components/schemas/AutoscalingAction'
        ruleCondition:
          $ref: '#/components/schemas/AutoscalingRuleCondition'
        ruleId:
          type: string
    NsDf:
      title: NsDf
      type: object
      properties:
        affinityOrAntiAffinityGroup:
          type: array
          items:
            $ref: '#/components/schemas/AffinityOrAntiAffinityGroup'
        defaultNsInstantiationLevelId:
          type: string
        dependencies:
          type: array
          items:
            $ref: '#/components/schemas/Dependencies'
        flavourKey:
          type: string
        nsDfId:
          type: string
        nsInstantiationLevel:
          type: array
          items:
            $ref: '#/components/schemas/NsLevel'
        nsProfile:
          type: array
          items:
            $ref: '#/components/schemas/NsProfile'
        pnfProfile:
          type: array
          items:
            $ref: '#/components/schemas/PnfProfile'
        scalingAspect:
          type: array
          items:
            $ref: '#/components/schemas/NsScalingAspect'
        virtualLinkProfile:
          type: array
          items:
            $ref: '#/components/schemas/VirtualLinkProfile'
        vnfProfile:
          type: array
          items:
            $ref: '#/components/schemas/VnfProfile'
    NsInfo:
      title: NsInfo
      type: object
      properties:
        description:
          type: string
        nSInstanceId:
          type: string
        nsName:
          type: string
    NsLevel:
      title: NsLevel
      type: object
      properties:
        description:
          type: string
        nsLevelId:
          type: string
        nsToLevelMapping:
          type: array
          items:
            $ref: '#/components/schemas/NsToLevelMapping'
        virtualLinkToLevelMapping:
          type: array
          items:
            $ref: '#/components/schemas/VirtualLinkToLevelMapping'
        vnfToLevelMapping:
          type: array
          items:
            $ref: '#/components/schemas/VnfToLevelMapping'
    NsProfile:
      title: NsProfile
      type: object
      properties:
        affinityOrAntiaffinityGroupId:
          type: array
          items:
            type: string
        maxNumberOfInstances:
          type: integer
          format: int32
        minNumberOfInstances:
          type: integer
          format: int32
        nsDfId:
          type: string
        nsInstantiationLevelId:
          type: string
        nsProfileId:
          type: string
        nsVirtualLinkConnectivity:
          type: array
          items:
            $ref: '#/components/schemas/NsVirtualLinkConnectivity'
        nsdId:
          type: string
    NsScaleInfo:
      title: NsScaleInfo
      type: object
      properties:
        nsScaleLevelId:
          type: string
        nsScalingAspectId:
          type: string
    NsScalingAspect:
      title: NsScalingAspect
      type: object
      properties:
        description:
          type: string
        name:
          type: string
        nsScaleLevel:
          type: array
          items:
            $ref: '#/components/schemas/NsLevel'
        nsScalingAspectId:
          type: string
    NsTemplateInfo:
      title: NsTemplateInfo
      type: object
      properties:
        deletionPending:
          type: boolean
        designer:
          type: string
        name:
          type: string
        nsTemplateId:
          type: string
        nsTemplateVersion:
          type: string
        nst:
          $ref: '#/components/schemas/NST'
        nstInfoId:
          type: string
        operationalState:
          type: string
          enum:
          - ENABLED
          - DISABLED
        referenceGstId:
          type: string
        referenceNsstsId:
          type: array
          items:
            type: string
        sst:
          type: string
        usageState:
          type: string
          enum:
          - IN_USE
          - NOT_IN_USE
        userDefinedData:
          type: object
          additionalProperties:
            type: string
    NsToLevelMapping:
      title: NsToLevelMapping
      type: object
      properties:
        nsProfileId:
          type: string
        numberOfInstances:
          type: integer
          format: int32
    NsVirtualLinkConnectivity:
      title: NsVirtualLinkConnectivity
      type: object
      properties:
        cpdId:
          type: array
          items:
            type: string
        virtualLinkProfileId:
          type: string
    NsVirtualLinkDesc:
      title: NsVirtualLinkDesc
      type: object
      properties:
        connectivityType:
          $ref: '#/components/schemas/ConnectivityType'
        description:
          type: string
        security:
          $ref: '#/components/schemas/SecurityParameters'
        testAccess:
          type: array
          items:
            type: string
        virtuaLinkDescVersion:
          type: string
        virtualLinkDescId:
          type: string
        virtualLinkDescProvider:
          type: string
        virtualLinkDf:
          type: array
          items:
            $ref: '#/components/schemas/VirtualLinkDf'
    Nsd:
      title: Nsd
      type: object
      properties:
        autoScalingRule:
          type: array
          items:
            $ref: '#/components/schemas/NsAutoscalingRule'
        designer:
          type: string
        lifeCycleManagementScript:
          type: array
          items:
            $ref: '#/components/schemas/LifeCycleManagementScript'
        monitoredInfo:
          type: array
          items:
            $ref: '#/components/schemas/MonitoredData'
        nestedNsdId:
          type: array
          items:
            type: string
        nsDf:
          type: array
          items:
            $ref: '#/components/schemas/NsDf'
        nsdIdentifier:
          type: string
        nsdInvariantId:
          type: string
        nsdName:
          type: string
        pnfdId:
          type: array
          items:
            type: string
        sapd:
          type: array
          items:
            $ref: '#/components/schemas/Sapd'
        security:
          $ref: '#/components/schemas/SecurityParameters'
        version:
          type: string
        virtualLinkDesc:
          type: array
          items:
            $ref: '#/components/schemas/NsVirtualLinkDesc'
        vnfdId:
          type: array
          items:
            type: string
        vnffgd:
          type: array
          items:
            $ref: '#/components/schemas/Vnffgd'
    NsdInfo:
      title: NsdInfo
      type: object
      properties:
        nsdDescription:
          type: string
        nsdId:
          type: string
        nsdName:
          type: string
        nsdVersion:
          type: string
   
    
    NssTemplateInfo:
      title: NssTemplateInfo
      type: object
      properties:
        deletionPending:
          type: boolean
        designer:
          type: string
        name:
          type: string
        nssTemplateId:
          type: string
        nssTemplateVersion:
          type: string
        nsst:
          $ref: '#/components/schemas/NSST'
        nsstInfoId:
          type: string
        operationalState:
          type: string
          enum:
          - ENABLED
          - DISABLED
        referenceGstId:
          type: string
        referenceNstId:
          type: string
        usageState:
          type: string
          enum:
          - IN_USE
          - NOT_IN_USE
    NstConfigurationRule:
      title: NstConfigurationRule
      type: object
      properties:
        name:
          type: string
        nsdId:
          type: string
        params:
          type: array
          items:
            type: string
        type:
          type: string
          enum:
          - REST
          - SSH
    NstServiceProfile:
      title: NstServiceProfile
      type: object
      properties:
        activityFactor:
          type: number
          format: float
        availability:
          type: number
          format: float
        coverageArea:
          type: string
        dLThptPerSlice:
          type: integer
          format: int32
        dLThptPerUE:
          type: integer
          format: int32
        delayTolerance:
          type: boolean
        deterministicComm:
          $ref: '#/components/schemas/DeterministicCommunication'
        guaThpt:
          type: number
          format: float
        jitter:
          type: integer
          format: int32
        kPIMonitoringList:
          type: array
          items:
            type: number
            format: float
        latency:
          type: integer
          format: int32
        maxNumberofConns:
          type: integer
          format: int32
        maxNumberofUEs:
          type: integer
          format: int32
        maxPktSize:
          type: integer
          format: int32
        maxThpt:
          type: number
          format: float
        pLMNIdList:
          type: array
          items:
            type: string
        reliability:
          type: string
        resourceSharingLevel:
          type: boolean
        resourceType:
          type: string
          enum:
          - GBR
          - DelayCriticalGBR
          - NonGBR
        sST:
          type: string
          enum:
          - EMBB
          - URLLC
          - MMTC
        serviceProfileId:
          type: string
        survivalTime:
          type: string
        termDensity:
          type: integer
          format: int32
        uEMobilityLevel:
          type: string
          enum:
          - STATIONARY
          - NOMADIC
          - RESTRICTED_MOBILITY
          - FULLY_MOBILITY
        uESpeed:
          type: integer
          format: int32
        uLThptPerSlice:
          type: integer
          format: int32
        uLThptPerUE:
          type: integer
          format: int32
        userMgmtOpen:
          type: boolean
        v2xMode:
          type: boolean
    OnBoardNesTemplateRequest:
      title: OnBoardNesTemplateRequest
      type: object
      properties:
        gst:
          $ref: '#/components/schemas/GST'
        nsds:
          type: array
          items:
            $ref: '#/components/schemas/Nsd'
        nstId:
          type: string
        pnfds:
          type: array
          items:
            $ref: '#/components/schemas/Pnfd'
        vnfPackages:
          type: array
          items:
            $ref: '#/components/schemas/OnBoardVnfPackageRequest'
    OnBoardNsTemplateRequest:
      title: OnBoardNsTemplateRequest
      type: object
      properties:
        configurationRules:
          type: array
          items:
            $ref: '#/components/schemas/NstConfigurationRule'
        nsds:
          type: array
          items:
            $ref: '#/components/schemas/Nsd'
        nst:
          $ref: '#/components/schemas/NST'
        pnfds:
          type: array
          items:
            $ref: '#/components/schemas/Pnfd'
        vnfPackages:
          type: array
          items:
            $ref: '#/components/schemas/OnBoardVnfPackageRequest'
    OnBoardNssTemplateRequest:
      title: OnBoardNssTemplateRequest
      type: object
      properties:
        nsds:
          type: array
          items:
            $ref: '#/components/schemas/Nsd'
        nssts:
          type: array
          items:
            $ref: '#/components/schemas/NSST'
        pnfds:
          type: array
          items:
            $ref: '#/components/schemas/Pnfd'
        vnfPackages:
          type: array
          items:
            $ref: '#/components/schemas/OnBoardVnfPackageRequest'
    OnBoardVnfPackageRequest:
      title: OnBoardVnfPackageRequest
      type: object
      properties:
        checksum:
          type: string
        name:
          type: string
        provider:
          type: string
        userDefinedData:
          type: object
          additionalProperties:
            type: string
        version:
          type: string
        vnfPackagePath:
          type: string
    PerformanceMonitoring:
      title: PerformanceMonitoring
      type: object
      properties:
        availability:
          type: array
          items:
            type: number
            format: float
        frequency:
          type: string
          enum:
          - PerSecond
          - PerMinute
          - PerHour
    PerformancePrediction:
      title: PerformancePrediction
      type: object
      properties:
        availability:
          type: array
          items:
            type: string
            enum:
            - Throughput
            - Latency
            - SRSR
        predictionFrequency:
          type: string
          enum:
          - PerSecond
          - PerMinute
          - PerHour
    PnfExtCpd:
      title: PnfExtCpd
      type: object
      properties:
        addressData:
          type: array
          items:
            $ref: '#/components/schemas/AddressData'
        cpRole:
          type: string
          enum:
          - ROOT
          - LEAF
        cpdId:
          type: string
        description:
          type: string
        layerProtocol:
          type: string
          enum:
          - ETHERNET
          - MPLS
          - ODU2
          - IPV4
          - IPV6
          - PSEUDO_WIRE
          - OTSIA
          - OCH
          - OTU
          - ODU
          - SDM
          - AROF
          - OBFN
          - NOT_SPECIFIED
    PnfProfile:
      title: PnfProfile
      type: object
      properties:
        pnfProfileId:
          type: string
        pnfVirtualLinkConnectivity:
          type: array
          items:
            $ref: '#/components/schemas/NsVirtualLinkConnectivity'
        pnfdId:
          type: string
    Pnfd:
      title: Pnfd
      type: object
      properties:
        configurableProperty:
          type: array
          items:
            type: string
        pnfExtCp:
          type: array
          items:
            $ref: '#/components/schemas/PnfExtCpd'
        pnfdId:
          type: string
        provider:
          type: string
        security:
          $ref: '#/components/schemas/SecurityParameters'
        version:
          type: string
    PositioningSupport:
      title: PositioningSupport
      type: object
      properties:
        accuracy:
          type: number
          format: float
        availability:
          type: array
          items:
            type: string
            enum:
            - CIDECID
            - OTDOA
            - RFfingerprinting
            - AECID
            - HybridPositioning
            - NETRTK
        frequency:
          type: string
          enum:
          - PerSecond
          - PerMinute
          - PerHour
    QoS:
      title: QoS
      type: object
      properties:
        latency:
          type: integer
          format: int32
        packetDelayVariation:
          type: integer
          format: int32
        packetLossRatio:
          type: integer
          format: int32
        priority:
          type: integer
          format: int32
    RadioSpectrum:
      title: RadioSpectrum
      type: object
      properties:
        eutraOperatingBands:
          type: array
          items:
            type: string
            enum:
            - eutra1
            - eutra2
            - eutra3
            - eutra4
            - eutra5
            - eutra7
            - eutra8
            - eutra9
            - eutra10
            - eutra11
            - eutra12
            - eutra13
            - eutra14
            - eutra17
            - eutra18
            - eutra19
            - eutra20
            - eutra21
            - eutra22
            - eutra24
            - eutra25
            - eutra26
            - eutra27
            - eutra28
            - eutra29
            - eutra31
            - eutra32
            - eutra33
            - eutra34
            - eutra35
            - eutra36
            - eutra37
            - eutra38
            - eutra39
            - eutra40
            - eutra41
            - eutra42
            - eutra43
            - eutra44
            - eutra45
            - eutra46
            - eutra47
            - eutra48
            - eutra49
            - eutra50
            - eutra51
            - eutra52
            - eutra65
            - eutra66
            - eutra67
            - eutra68
            - eutra69
            - eutra70
            - eutra71
            - eutra72
            - eutra73
            - eutra74
            - eutra75
            - eutra76
            - eutra85
        nrOperatingBands:
          type: array
          items:
            type: string
            enum:
            - n1
            - n2
            - n3
            - n5
            - n7
            - n8
            - n12
            - n20
            - n25
            - n28
            - n34
            - n38
            - n39
            - n40
            - n41
            - n51
            - n66
            - n70
            - n71
            - n75
            - n76
            - n77
            - n78
            - n79
            - n80
            - n81
            - n82
            - n83
            - n84
            - n86
 
    ResponseEntity:
      title: ResponseEntity
      type: object
      properties:
        body:
          type: object
          properties: {}
        statusCode:
          type: string
          enum:
          - "100"
          - "101"
          - "102"
          - "103"
          - "200"
          - "201"
          - "202"
          - "203"
          - "204"
          - "205"
          - "206"
          - "207"
          - "208"
          - "226"
          - "300"
          - "301"
          - "302"
          - "303"
          - "304"
          - "305"
          - "307"
          - "308"
          - "400"
          - "401"
          - "402"
          - "403"
          - "404"
          - "405"
          - "406"
          - "407"
          - "408"
          - "409"
          - "410"
          - "411"
          - "412"
          - "413"
          - "414"
          - "415"
          - "416"
          - "417"
          - "418"
          - "419"
          - "420"
          - "421"
          - "422"
          - "423"
          - "424"
          - "426"
          - "428"
          - "429"
          - "431"
          - "451"
          - "500"
          - "501"
          - "502"
          - "503"
          - "504"
          - "505"
          - "506"
          - "507"
          - "508"
          - "509"
          - "510"
          - "511"
        statusCodeValue:
          type: integer
          format: int32

    Rule:
      title: Rule
      type: object
    Sapd:
      title: Sapd
      type: object
      properties:
        addressData:
          type: array
          items:
            $ref: '#/components/schemas/AddressData'
        associatedCpdId:
          type: string
        cpRole:
          type: string
          enum:
          - ROOT
          - LEAF
        cpdId:
          type: string
        description:
          type: string
        layerProtocol:
          type: string
          enum:
          - ETHERNET
          - MPLS
          - ODU2
          - IPV4
          - IPV6
          - PSEUDO_WIRE
          - OTSIA
          - OCH
          - OTU
          - ODU
          - SDM
          - AROF
          - OBFN
          - NOT_SPECIFIED
        nsVirtualLinkDescId:
          type: string
        sapAddressAssignment:
          type: boolean
    ScaleNsToLevelData:
      title: ScaleNsToLevelData
      type: object
      properties:
        nsInstantiationLevel:
          type: string
        nsScaleInfo:
          type: array
          items:
            $ref: '#/components/schemas/NsScaleInfo'
    SecurityParameters:
      title: SecurityParameters
      type: object
      properties:
        algorithm:
          type: string
        certificate:
          type: string
        signature:
          type: string
    SliceProfile:
      title: SliceProfile
      type: object
      properties:
        coverageAreaTAList:
          type: array
          items:
            type: string
        eMBBPerfReq:
          type: array
          items:
            $ref: '#/components/schemas/EMBBPerfReq'
        latency:
          type: integer
          format: int32
        maxNumberofUEs:
          type: integer
          format: int32
        pLMNIdList:
          type: array
          items:
            type: string
        resourceSharingLevel:
          type: boolean
        sliceProfileId:
          type: string
        uEMobilityLevel:
          type: string
          enum:
          - STATIONARY
          - NOMADIC
          - RESTRICTED_MOBILITY
          - FULLY_MOBILITY
        uRLLCPerfReq:
          type: array
          items:
            $ref: '#/components/schemas/URLLCPerfReq'
    SliceQoSparams:
      title: SliceQoSparams
      type: object
      properties:
        averagingWindow:
          type: number
          format: float
        maxDataBurstVolume:
          type: integer
          format: int32
        maxPacketLossRate:
          type: integer
          format: int32
        packerErrorRate:
          type: number
          format: float
        packetDelayBudget:
          type: number
          format: float
        priorityLevel:
          type: integer
          format: int32
        qosIndicator:
          type: string
          enum:
          - qi1
          - qi2
          - qi3
          - qi4
          - qi65
          - qi66
          - qi67
          - qi75
          - qi71
          - qi72
          - qi73
          - qi74
          - qi76
          - qi5
          - qi6
          - qi7
          - qi8
          - qi9
          - qi69
          - qi70
          - qi79
          - qi80
          - qi82
          - qi83
          - qi84
          - qi85
          - qi86
        resourceType:
          type: string
          enum:
          - GBR
          - DelayCriticalGBR
          - NonGBR
    Synchronicity:
      title: Synchronicity
      type: object
      properties:
        accouracy:
          type: number
          format: float
        accuracy:
          type: number
          format: float
        availability:
          type: string
          enum:
          - NotSupported
          - BetweenBSandUE
          - BetweenBSandUE_UEandUE
    URLLCPerfReq:
      title: URLLCPerfReq
      type: object
      properties:
        csavailabilityTarget:
          type: number
          format: float
        csreliabilityMeanTime:
          type: string
        expDataRate:
          type: integer
          format: int32
        msgSizeByte:
          type: string
        survivalTime:
          type: string
        transferIntervalTarget:
          type: string
   
    UplinkThroughputNS:
      title: UplinkThroughputNS
      type: object
      properties:
        additionalUplink:
          type: boolean
        guaranteedUplinkThroughput:
          type: integer
          format: int32
        maxUplinkThroughput:
          type: integer
          format: int32
    UserDataAccess:
      title: UserDataAccess
      type: object
      properties:
        dataAccess:
          type: string
          enum:
          - DirectInternetAccess
          - TerminationInPrivateNetwork
          - LocalTraffic_NoInternetTraffic
        thunnelingMechanisms:
          type: array
          items:
            type: string
            enum:
            - L2TPTunnel
            - GRETunnel
            - VPNTunnel
            - LabelBasesRouting
            - Other
    VirtualLinkDf:
      title: VirtualLinkDf
      type: object
      properties:
        flavourId:
          type: string
        qos:
          $ref: '#/components/schemas/QoS'
        serviceAvaibilityLevel:
          type: string
          enum:
          - LEVEL_1
          - LEVEL_2
          - LEVEL_3
    VirtualLinkProfile:
      title: VirtualLinkProfile
      type: object
      properties:
        affinityOrAntiAffinityGroupId:
          type: array
          items:
            type: string
        flavourId:
          type: string
        localAffinityOrAntiAffinityRule:
          type: array
          items:
            $ref: '#/components/schemas/AffinityRule'
        maxBitrateRequirements:
          $ref: '#/components/schemas/LinkBitrateRequirements'
        minBitrateRequirements:
          $ref: '#/components/schemas/LinkBitrateRequirements'
        virtualLinkDescId:
          type: string
        virtualLinkProfileId:
          type: string
    VirtualLinkToLevelMapping:
      title: VirtualLinkToLevelMapping
      type: object
      properties:
        bitRateRequirements:
          $ref: '#/components/schemas/LinkBitrateRequirements'
        virtualLinkProfileId:
          type: string
    VnfIndicatorData:
      title: VnfIndicatorData
      type: object
      properties:
        vnfIndicator:
          type: string
        vnfdId:
          type: string
    VnfLCMScripts:
      title: VnfLCMScripts
      type: object
      properties:
        target:
          type: string
    VnfProfile:
      title: VnfProfile
      type: object
      properties:
        affinityOrAntiAffinityGroupId:
          type: array
          items:
            type: string
        flavourId:
          type: string
        instantiationLevel:
          type: string
        localAffinityOrAntiAffinityRule:
          type: array
          items:
            $ref: '#/components/schemas/AffinityRule'
        maxNumberOfInstances:
          type: integer
          format: int32
        minNumberOfInstances:
          type: integer
          format: int32
        nsVirtualLinkConnectivity:
          type: array
          items:
            $ref: '#/components/schemas/NsVirtualLinkConnectivity'
        script:
          type: array
          items:
            $ref: '#/components/schemas/VnfLCMScripts'
        vnfProfileId:
          type: string
        vnfdId:
          type: string
    VnfToLevelMapping:
      title: VnfToLevelMapping
      type: object
      properties:
        numberOfInstances:
          type: integer
          format: int32
        vnfProfileId:
          type: string
    Vnffgd:
      title: Vnffgd
      type: object
      properties:
        cpdPoolId:
          type: array
          items:
            type: string
        nfpd:
          type: array
          items:
            $ref: '#/components/schemas/Nfpd'
        pnfdId:
          type: array
          items:
            type: string
        virtualLinkDescId:
          type: array
          items:
            type: string
        vnfdId:
          type: array
          items:
            type: string
        vnffgdId:
          type: string

